from PyQt5 import QtGui, QtCore
from PyQt5.QtWidgets import QApplication, QMainWindow, QGraphicsScene, QGraphicsView, QGraphicsItem, QGraphicsLineItem, QGraphicsEllipseItem, QGraphicsItemGroup
from PyQt5.QtGui import QPen, QBrush
from PyQt5.Qt import Qt
 
import sys
 
class Window(QMainWindow):
    def __init__(self):
        super().__init__()
 
        self.title = "Пример группировки объектов"
        self.top = 200
        self.left = 500
        self.width = 400
        self.height = 300

        self.pos = 0 # Смещение 
        self.YN = True # Присутствует или нет линия в группе
        
        self.setWindowTitle(self.title)
        # Задание местоположения и размера окна
        self.setGeometry(self.left, self.top, self.width, self.height)
        self.scene = QGraphicsScene()
        # Создание инструмента для отрисовки графической сцены
        self.graphicView = QGraphicsView(self.scene, self)
        # Задание местоположения и размера графической сцены
        self.graphicView.setGeometry(0, 0, self.width, self.height)
  
    def plot(self):
        # Задание цветов
        color = Qt.green
        color1 = Qt.red
        color2 = Qt.blue
        # Создание эллипса
        self.ellipse = QGraphicsEllipseItem(50, 50, 200, 200)
        # Определение цвета границы и заполнения
        self.ellipse.setPen(QPen(color1))
        self.ellipse.setBrush(color)
        # Создание линии
        self.line = QGraphicsLineItem(30, 30, 250, 30)
        # Определение ее цвета
        self.line.setPen(QPen(color2))
        # Создание группы
        self.group = QGraphicsItemGroup()
        # Добавление в группу эллипса и линии
        self.group.addToGroup(self.ellipse)
        self.group.addToGroup(self.line)
        # Добавление группы на сцену
        self.scene.addItem(self.group)

    def keyPressEvent(self, event):
        # Обработчик нажатия клавиш
        # Q - смещение группы на 5 пикселей вправо
        # W - смещение группы на 5 пикселей влево
        # Z - удаление/добавлени линии в группу
        if event.key() == QtCore.Qt.Key_Q:   # Q
            self.pos += 5
            self.group.setX(self.pos)
        elif event.key() == QtCore.Qt.Key_W: # W
            self.pos -= 5
            self.group.setX(self.pos)
        elif event.key() == QtCore.Qt.Key_Z: # Z 
            if self.YN == True: # Если линия есть в группе...
                # ... то удаляем ее
                self.group.removeFromGroup(self.line)
                self.YN = False
            else: # Если линии нет в группе...
                # ... то добавляем ее
                self.group.addToGroup(self.line)
                self.YN = True
        event.accept() # Завершение обработки события

 
App = QApplication(sys.argv)
window = Window()
window.show() # Демонстрация окна
window.plot() # Построение и перерисовка окна

sys.exit(App.exec())
